Index: src/log.cpp
===================================================================
--- src/log.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/log.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -16,5 +16,4 @@
 void setVerbosity(int verbosityLevel) {
   logger::getInstance()->setVerbosity(verbosityLevel);
-  errorLogger::getInstance()->setVerbosity(verbosityLevel);
 }
 
@@ -28,4 +27,26 @@
 }
 
+/** Checks verbosity for logger.
+ * Is supposed to be used in construct as this:
+ * DoLog(2) && (Log() << Verbose(2) << "message." << endl);
+ * If DoLog does not return true, the right-hand side is not evaluated and we save some time.
+ * \param verbose verbosity level of this message
+ * \return true - print, false - don't
+ */
+bool DoLog(int verbose) {
+  return (verbose <= logger::getInstance()->verbosity);
+}
+
+/** Checks verbosity for errorlogger.
+ * Is supposed to be used in construct as this:
+ * DoLog(2) && (Log() << Verbose(2) << "message." << endl);
+ * If DoLog does not return true, the right-hand side is not evaluated and we save some time.
+ * \param verbose verbosity level of this message
+ * \return true - print, false - don't
+ */
+bool DoeLog(int verbose) {
+  return (verbose <= errorLogger::getInstance()->verbosity);
+}
+
 /**
  * Prints an error log entry.
Index: src/log.hpp
===================================================================
--- src/log.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/log.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -15,4 +15,6 @@
 class errorLogger * eLog();
 void setVerbosity(int verbosityLevel);
+bool DoLog(int verbose);
+bool DoeLog(int verbose);
 
 #endif /* LOG_HPP_ */
Index: src/logger.cpp
===================================================================
--- src/logger.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/logger.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -81,7 +81,8 @@
   int verbosityLevel = l.verbosity;
   l.nix->clear();
-  if (v.DoOutput(verbosityLevel))
+  if (v.DoOutput(verbosityLevel)) {
+    v.print(cout);
     return cout;
-  else
+  } else
     return *l.nix;
 };
@@ -90,7 +91,8 @@
   int verbosityLevel = l->verbosity;
   l->nix->clear();
-  if (v.DoOutput(verbosityLevel))
+  if (v.DoOutput(verbosityLevel)) {
+    v.print(cout);
     return cout;
-  else
+  } else
     return *l->nix;
 };
Index: src/memoryallocator.hpp
===================================================================
--- src/memoryallocator.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/memoryallocator.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -16,4 +16,5 @@
 #endif
 
+#include <cstdlib>
 #include <iostream>
 #include <iomanip>
Index: src/memoryusageobserver.cpp
===================================================================
--- src/memoryusageobserver.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/memoryusageobserver.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -4,4 +4,6 @@
  * This class represents a Singleton for observing memory usage.
  */
+
+#include <cstdlib>
 
 #include "log.hpp"
@@ -88,9 +90,9 @@
 
   if (current == memoryUsers.end()) {
-    Log() << Verbose(0) << "WARNING: There is non-tracked memory to be freed. Pointer "
+    eLog() << Verbose(2) << "There is non-tracked memory to be freed. Pointer "
       << pointer << " is not registered by MemoryUsageObserver: ";
     if (msg != NULL)
-      Log() << Verbose(0) << *msg;
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << *msg);
+    DoLog(0) && (Log() << Verbose(0) << endl);
     return;
   }
Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -4,4 +4,6 @@
  *
  */
+
+#include <cstring>
 
 #include "atom.hpp"
@@ -21,4 +23,5 @@
 #include "tesselation.hpp"
 #include "vector.hpp"
+#include "World.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -43,7 +46,5 @@
   for(int i=MAX_ELEMENTS;i--;)
     ElementsInMolecule[i] = 0;
-  cell_size[0] = cell_size[2] = cell_size[5]= 20.;
-  cell_size[1] = cell_size[3] = cell_size[4]= 0.;
-  strcpy(name,"none");
+  strcpy(name,World::get()->DefaultName);
 };
 
@@ -157,4 +158,5 @@
   double *matrix = NULL;
   bond *Binder = NULL;
+  double * const cell_size = World::get()->cell_size;
 
 //  Log() << Verbose(3) << "Begin of AddHydrogenReplacementAtom." << endl;
@@ -192,5 +194,5 @@
   BondRescale = TopOrigin->type->HBondDistance[TopBond->BondDegree-1];
   if (BondRescale == -1) {
-    eLog() << Verbose(3) << "ERROR: There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl);
     return false;
     BondRescale = bondlength;
@@ -235,5 +237,5 @@
             SecondOtherAtom = (*Runner)->GetOtherAtom(TopOrigin);
           } else {
-            Log() << Verbose(3) << "WARNING: Detected more than four bonds for atom " << TopOrigin->Name;
+            DoeLog(2) && (eLog()<< Verbose(2) << "Detected more than four bonds for atom " << TopOrigin->Name);
           }
         }
@@ -272,5 +274,5 @@
       bondangle = TopOrigin->type->HBondAngle[1];
       if (bondangle == -1) {
-        Log() << Verbose(3) << "ERROR: There is no typical hydrogen bond angle in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
+        DoeLog(1) && (eLog()<< Verbose(1) << "There is no typical hydrogen bond angle in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl);
         return false;
         bondangle = 0;
@@ -394,5 +396,5 @@
       break;
     default:
-      eLog() << Verbose(0) << "ERROR: BondDegree does not state single, double or triple bond!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "BondDegree does not state single, double or triple bond!" << endl);
       AllWentWell = false;
       break;
@@ -427,7 +429,7 @@
   input = new istringstream(line);
   *input >> NumberOfAtoms;
-  Log() << Verbose(0) << "Parsing " << NumberOfAtoms << " atoms in file." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Parsing " << NumberOfAtoms << " atoms in file." << endl);
   getline(xyzfile,line,'\n'); // Read comment
-  Log() << Verbose(1) << "Comment: " << line << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Comment: " << line << endl);
 
   if (MDSteps == 0) // no atoms yet present
@@ -445,5 +447,5 @@
     Walker->type = elemente->FindElement(shorthand);
     if (Walker->type == NULL) {
-      eLog() << Verbose(0) << "Could not parse the element at line: '" << line << "', setting to H.";
+      DoeLog(1) && (eLog()<< Verbose(1) << "Could not parse the element at line: '" << line << "', setting to H.");
       Walker->type = elemente->FindElement(1);
     }
@@ -541,5 +543,5 @@
     add(Binder, last);
   } else {
-    eLog() << Verbose(1) << "ERROR: Could not add bond between " << atom1->Name << " and " << atom2->Name << " as one or both are not present in the molecule." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Could not add bond between " << atom1->Name << " and " << atom2->Name << " as one or both are not present in the molecule." << endl);
   }
   return Binder;
@@ -553,5 +555,5 @@
 bool molecule::RemoveBond(bond *pointer)
 {
-  //eLog() << Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl;
+  //DoeLog(1) && (eLog()<< Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl);
   pointer->leftatom->RegisterBond(pointer);
   pointer->rightatom->RegisterBond(pointer);
@@ -567,5 +569,5 @@
 bool molecule::RemoveBonds(atom *BondPartner)
 {
-  //eLog() << Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl;
+  //DoeLog(1) && (eLog()<< Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl);
   BondList::const_iterator ForeRunner;
   while (!BondPartner->ListOfBonds.empty()) {
@@ -587,5 +589,5 @@
   else
     molname = filename; // contains no slashes
-  char *endname = strchr(molname, '.');
+  const char *endname = strchr(molname, '.');
   if ((endname == NULL) || (endname < molname))
     length = strlen(molname);
@@ -601,4 +603,5 @@
 void molecule::SetBoxDimension(Vector *dim)
 {
+  double * const cell_size = World::get()->cell_size;
   cell_size[0] = dim->x[0];
   cell_size[1] = 0.;
@@ -619,5 +622,5 @@
     AtomCount--;
   } else
-    eLog() << Verbose(0) << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl);
   if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
     ElementCount--;
@@ -637,5 +640,5 @@
     ElementsInMolecule[pointer->type->Z]--; // decrease number of atom of this element
   else
-    eLog() << Verbose(0) << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl);
   if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
     ElementCount--;
@@ -662,5 +665,5 @@
     return walker;
   } else {
-    Log() << Verbose(0) << "Atom not found in list." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Atom not found in list." << endl);
     return NULL;
   }
@@ -678,5 +681,5 @@
     //mol->Output((ofstream *)&cout);
     //Log() << Verbose(0) << "===============================================" << endl;
-    Log() << Verbose(0) << text;
+    DoLog(0) && (Log() << Verbose(0) << text);
     cin >> No;
     ion = this->FindAtom(No);
@@ -691,4 +694,5 @@
 bool molecule::CheckBounds(const Vector *x) const
 {
+  double * const cell_size = World::get()->cell_size;
   bool result = true;
   int j =-1;
@@ -766,7 +770,7 @@
 void molecule::OutputListOfBonds() const
 {
-  Log() << Verbose(2) << endl << "From Contents of ListOfBonds, all non-hydrogen atoms:" << endl;
+  DoLog(2) && (Log() << Verbose(2) << endl << "From Contents of ListOfBonds, all non-hydrogen atoms:" << endl);
   ActOnAllAtoms (&atom::OutputBondOfAtom );
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
 };
 
@@ -825,5 +829,5 @@
   }
   if ((AtomCount == 0) || (i != AtomCount)) {
-    Log() << Verbose(3) << "Mismatch in AtomCount " << AtomCount << " and recounted number " << i << ", renaming all." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Mismatch in AtomCount " << AtomCount << " and recounted number " << i << ", renaming all." << endl);
     AtomCount = i;
 
@@ -841,9 +845,9 @@
         Walker->Name = Malloc<char>(6, "molecule::CountAtoms: *walker->Name");
         sprintf(Walker->Name, "%2s%02d", Walker->type->symbol, Walker->nr+1);
-        Log() << Verbose(3) << "Naming atom nr. " << Walker->nr << " " << Walker->Name << "." << endl;
+        DoLog(3) && (Log() << Verbose(3) << "Naming atom nr. " << Walker->nr << " " << Walker->Name << "." << endl);
         i++;
       }
     } else
-      Log() << Verbose(3) << "AtomCount is still " << AtomCount << ", thus counting nothing." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "AtomCount is still " << AtomCount << ", thus counting nothing." << endl);
   }
 };
@@ -905,5 +909,5 @@
   bool result = true; // status of comparison
 
-  Log() << Verbose(3) << "Begin of IsEqualToWithinThreshold." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "Begin of IsEqualToWithinThreshold." << endl);
   /// first count both their atoms and elements and update lists thereby ...
   //Log() << Verbose(0) << "Counting atoms, updating list" << endl;
@@ -917,5 +921,5 @@
   if (result) {
     if (AtomCount != OtherMolecule->AtomCount) {
-      Log() << Verbose(4) << "AtomCounts don't match: " << AtomCount << " == " << OtherMolecule->AtomCount << endl;
+      DoLog(4) && (Log() << Verbose(4) << "AtomCounts don't match: " << AtomCount << " == " << OtherMolecule->AtomCount << endl);
       result = false;
     } else Log() << Verbose(4) << "AtomCounts match: " << AtomCount << " == " << OtherMolecule->AtomCount << endl;
@@ -924,5 +928,5 @@
   if (result) {
     if (ElementCount != OtherMolecule->ElementCount) {
-      Log() << Verbose(4) << "ElementCount don't match: " << ElementCount << " == " << OtherMolecule->ElementCount << endl;
+      DoLog(4) && (Log() << Verbose(4) << "ElementCount don't match: " << ElementCount << " == " << OtherMolecule->ElementCount << endl);
       result = false;
     } else Log() << Verbose(4) << "ElementCount match: " << ElementCount << " == " << OtherMolecule->ElementCount << endl;
@@ -936,5 +940,5 @@
     }
     if (flag < MAX_ELEMENTS) {
-      Log() << Verbose(4) << "ElementsInMolecule don't match." << endl;
+      DoLog(4) && (Log() << Verbose(4) << "ElementsInMolecule don't match." << endl);
       result = false;
     } else Log() << Verbose(4) << "ElementsInMolecule match." << endl;
@@ -942,14 +946,14 @@
   /// then determine and compare center of gravity for each molecule ...
   if (result) {
-    Log() << Verbose(5) << "Calculating Centers of Gravity" << endl;
+    DoLog(5) && (Log() << Verbose(5) << "Calculating Centers of Gravity" << endl);
     DeterminePeriodicCenter(CenterOfGravity);
     OtherMolecule->DeterminePeriodicCenter(OtherCenterOfGravity);
-    Log() << Verbose(5) << "Center of Gravity: ";
+    DoLog(5) && (Log() << Verbose(5) << "Center of Gravity: ");
     CenterOfGravity.Output();
-    Log() << Verbose(0) << endl << Verbose(5) << "Other Center of Gravity: ";
+    DoLog(0) && (Log() << Verbose(0) << endl << Verbose(5) << "Other Center of Gravity: ");
     OtherCenterOfGravity.Output();
-    Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl);
     if (CenterOfGravity.DistanceSquared(&OtherCenterOfGravity) > threshold*threshold) {
-      Log() << Verbose(4) << "Centers of gravity don't match." << endl;
+      DoLog(4) && (Log() << Verbose(4) << "Centers of gravity don't match." << endl);
       result = false;
     }
@@ -958,5 +962,5 @@
   /// ... then make a list with the euclidian distance to this center for each atom of both molecules
   if (result) {
-    Log() << Verbose(5) << "Calculating distances" << endl;
+    DoLog(5) && (Log() << Verbose(5) << "Calculating distances" << endl);
     Distances = Calloc<double>(AtomCount, "molecule::IsEqualToWithinThreshold: Distances");
     OtherDistances = Calloc<double>(AtomCount, "molecule::IsEqualToWithinThreshold: OtherDistances");
@@ -965,5 +969,5 @@
 
     /// ... sort each list (using heapsort (o(N log N)) from GSL)
-    Log() << Verbose(5) << "Sorting distances" << endl;
+    DoLog(5) && (Log() << Verbose(5) << "Sorting distances" << endl);
     PermMap = Calloc<size_t>(AtomCount, "molecule::IsEqualToWithinThreshold: *PermMap");
     OtherPermMap = Calloc<size_t>(AtomCount, "molecule::IsEqualToWithinThreshold: *OtherPermMap");
@@ -971,13 +975,13 @@
     gsl_heapsort_index (OtherPermMap, OtherDistances, AtomCount, sizeof(double), CompareDoubles);
     PermutationMap = Calloc<int>(AtomCount, "molecule::IsEqualToWithinThreshold: *PermutationMap");
-    Log() << Verbose(5) << "Combining Permutation Maps" << endl;
+    DoLog(5) && (Log() << Verbose(5) << "Combining Permutation Maps" << endl);
     for(int i=AtomCount;i--;)
       PermutationMap[PermMap[i]] = (int) OtherPermMap[i];
 
     /// ... and compare them step by step, whether the difference is individually(!) below \a threshold for all
-    Log() << Verbose(4) << "Comparing distances" << endl;
+    DoLog(4) && (Log() << Verbose(4) << "Comparing distances" << endl);
     flag = 0;
     for (int i=0;i<AtomCount;i++) {
-      Log() << Verbose(5) << "Distances squared: |" << Distances[PermMap[i]] << " - " << OtherDistances[OtherPermMap[i]] << "| = " << fabs(Distances[PermMap[i]] - OtherDistances[OtherPermMap[i]]) << " ?<? " <<  threshold << endl;
+      DoLog(5) && (Log() << Verbose(5) << "Distances squared: |" << Distances[PermMap[i]] << " - " << OtherDistances[OtherPermMap[i]] << "| = " << fabs(Distances[PermMap[i]] - OtherDistances[OtherPermMap[i]]) << " ?<? " <<  threshold << endl);
       if (fabs(Distances[PermMap[i]] - OtherDistances[OtherPermMap[i]]) > threshold*threshold)
         flag = 1;
@@ -995,10 +999,10 @@
   }
   /// return pointer to map if all distances were below \a threshold
-  Log() << Verbose(3) << "End of IsEqualToWithinThreshold." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "End of IsEqualToWithinThreshold." << endl);
   if (result) {
-    Log() << Verbose(3) << "Result: Equal." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Result: Equal." << endl);
     return PermutationMap;
   } else {
-    Log() << Verbose(3) << "Result: Not equal." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Result: Not equal." << endl);
     return NULL;
   }
@@ -1015,5 +1019,5 @@
 {
   atom *Walker = NULL, *OtherWalker = NULL;
-  Log() << Verbose(3) << "Begin of GetFatherAtomicMap." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "Begin of GetFatherAtomicMap." << endl);
   int *AtomicMap = Malloc<int>(AtomCount, "molecule::GetAtomicMap: *AtomicMap");
   for (int i=AtomCount;i--;)
@@ -1022,7 +1026,7 @@
     for (int i=AtomCount;i--;) // no need as -1 means already that there is trivial correspondence
       AtomicMap[i] = i;
-    Log() << Verbose(4) << "Map is trivial." << endl;
+    DoLog(4) && (Log() << Verbose(4) << "Map is trivial." << endl);
   } else {
-    Log() << Verbose(4) << "Map is ";
+    DoLog(4) && (Log() << Verbose(4) << "Map is ");
     Walker = start;
     while (Walker->next != end) {
@@ -1041,9 +1045,9 @@
         }
       }
-      Log() << Verbose(0) << AtomicMap[Walker->nr] << "\t";
-    }
-    Log() << Verbose(0) << endl;
-  }
-  Log() << Verbose(3) << "End of GetFatherAtomicMap." << endl;
+      DoLog(0) && (Log() << Verbose(0) << AtomicMap[Walker->nr] << "\t");
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
+  }
+  DoLog(3) && (Log() << Verbose(3) << "End of GetFatherAtomicMap." << endl);
   return AtomicMap;
 };
Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -82,5 +82,4 @@
 class molecule : public PointCloud {
   public:
-    double cell_size[6];//!< cell size
     const periodentafel * const elemente; //!< periodic table with each element
     atom *start;        //!< start of atom list
@@ -106,7 +105,9 @@
 
   // re-definition of virtual functions from PointCloud
+  const char * const GetName() const;
   Vector *GetCenter() const ;
   TesselPoint *GetPoint() const ;
   TesselPoint *GetTerminalPoint() const ;
+  int GetMaxId() const;
   void GoToNext() const ;
   void GoToPrevious() const ;
@@ -267,5 +268,6 @@
   int FragmentMolecule(int Order, config *configuration);
   bool CheckOrderAtSite(bool *AtomMask, Graph *GlobalKeySetList, int Order, int *MinimumRingSize, char *path = NULL);
-  bool StoreAdjacencyToFile(char *path);
+  bool StoreBondsToFile(char *path, char *filename);
+  bool StoreAdjacencyToFile(char *path, char *filename);
   bool CheckAdjacencyFileAgainstMolecule(char *path, atom **ListOfAtoms);
   bool ParseOrderAtSiteFromFile(char *path);
@@ -321,5 +323,6 @@
   void Enumerate(ofstream *out);
   void Output(ofstream *out);
-  void DissectMoleculeIntoConnectedSubgraphs(molecule * const mol, config * const configuration);
+  void DissectMoleculeIntoConnectedSubgraphs(const periodentafel * const periode, config * const configuration);
+  int CountAllAtoms() const;
 
   // merging of molecules
Index: src/molecule_dynamics.cpp
===================================================================
--- src/molecule_dynamics.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule_dynamics.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -207,5 +207,5 @@
     doubles++;
   if (doubles >0)
-    Log() << Verbose(2) << "Found " << doubles << " Doubles." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Found " << doubles << " Doubles." << endl);
   Free(&DoubleList);
 //  Log() << Verbose(2) << zeile1.str() << endl << zeile2.str() << endl;
@@ -249,5 +249,5 @@
     Params.DoubleList[Params.DistanceList[Walker->nr]->begin()->second->nr]++;            // increase this target's source count (>1? not injective)
     Params.DistanceIterators[Walker->nr] = Params.DistanceList[Walker->nr]->begin();    // and remember which one we picked
-    Log() << Verbose(2) << *Walker << " starts with distance " << Params.DistanceList[Walker->nr]->begin()->first << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << *Walker << " starts with distance " << Params.DistanceList[Walker->nr]->begin()->first << "." << endl);
   }
 };
@@ -277,5 +277,5 @@
       Params.DistanceIterators[Walker->nr] = NewBase;
       OldPotential = Potential;
-      Log() << Verbose(3) << "Found a new permutation, new potential is " << OldPotential << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "Found a new permutation, new potential is " << OldPotential << "." << endl);
     }
   }
@@ -306,8 +306,8 @@
   for (int i=mol->AtomCount; i--;) // now each single entry in the DoubleList should be <=1
     if (Params.DoubleList[i] > 1) {
-      eLog() << Verbose(0) << "Failed to create an injective PermutationMap!" << endl;
-      exit(1);
-    }
-  Log() << Verbose(1) << "done." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Failed to create an injective PermutationMap!" << endl);
+      performCriticalExit();
+    }
+  DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 };
 
@@ -358,5 +358,5 @@
   Params.PenaltyConstants[2] = 1e+7;    // just a huge penalty
   // generate the distance list
-  Log() << Verbose(1) << "Allocating, initializting and filling the distance list ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Allocating, initializting and filling the distance list ... " << endl);
   FillDistanceList(this, Params);
 
@@ -365,14 +365,14 @@
 
   // make the PermutationMap injective by checking whether we have a non-zero constants[2] term in it
-  Log() << Verbose(1) << "Making the PermutationMap injective ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Making the PermutationMap injective ... " << endl);
   MakeInjectivePermutation(this, Params);
   Free(&Params.DoubleList);
 
   // argument minimise the constrained potential in this injective PermutationMap
-  Log() << Verbose(1) << "Argument minimising the PermutationMap, at current potential " << OldPotential << " ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Argument minimising the PermutationMap." << endl);
   OldPotential = 1e+10;
   round = 0;
   do {
-    Log() << Verbose(2) << "Starting round " << ++round << " ... " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Starting round " << ++round << ", at current potential " << OldPotential << " ... " << endl);
     OlderPotential = OldPotential;
     do {
@@ -424,14 +424,14 @@
             } else {
               Params.DistanceIterators[Runner->nr] = Rider;  // if successful also move the pointer in the iterator list
-              Log() << Verbose(3) << "Found a better permutation, new potential is " << Potential << " vs." << OldPotential << "." << endl;
+              DoLog(3) && (Log() << Verbose(3) << "Found a better permutation, new potential is " << Potential << " vs." << OldPotential << "." << endl);
               OldPotential = Potential;
             }
             if (Potential > Params.PenaltyConstants[2]) {
-              eLog() << Verbose(0) << "ERROR: The two-step permutation procedure did not maintain injectivity!" << endl;
+              DoeLog(1) && (eLog()<< Verbose(1) << "The two-step permutation procedure did not maintain injectivity!" << endl);
               exit(255);
             }
             //Log() << Verbose(0) << endl;
           } else {
-            eLog() << Verbose(0) << "ERROR: " << *Runner << " was not the owner of " << *Sprinter << "!" << endl;
+            DoeLog(1) && (eLog()<< Verbose(1) << *Runner << " was not the owner of " << *Sprinter << "!" << endl);
             exit(255);
           }
@@ -443,5 +443,5 @@
     } while (Walker->next != end);
   } while ((OlderPotential - OldPotential) > 1e-3);
-  Log() << Verbose(1) << "done." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 
 
@@ -466,7 +466,7 @@
 {
   /// evaluate forces (only the distance to target dependent part) with the final PermutationMap
-  Log() << Verbose(1) << "Calculating forces and adding onto ForceMatrix ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Calculating forces and adding onto ForceMatrix ... " << endl);
   ActOnAllAtoms( &atom::EvaluateConstrainedForce, startstep, endstep, PermutationMap, Force );
-  Log() << Verbose(1) << "done." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 };
 
@@ -503,5 +503,5 @@
 
   // go through all steps and add the molecular configuration to the list and to the Trajectories of \a this molecule
-  Log() << Verbose(1) << "Filling intermediate " << MaxSteps << " steps with MDSteps of " << MDSteps << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Filling intermediate " << MaxSteps << " steps with MDSteps of " << MDSteps << "." << endl);
   for (int step = 0; step <= MaxSteps; step++) {
     mol = new molecule(elemente);
@@ -568,9 +568,11 @@
     // parse file into ForceMatrix
     if (!Force.ParseMatrix(file, 0,0,0)) {
-      eLog() << Verbose(0) << "Could not parse Force Matrix file " << file << "." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse Force Matrix file " << file << "." << endl);
+      performCriticalExit();
       return false;
     }
     if (Force.RowCounter[0] != AtomCount) {
-      eLog() << Verbose(0) << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl);
+      performCriticalExit();
       return false;
     }
@@ -650,22 +652,22 @@
   switch(Thermostat) {
      case None:
-      Log() << Verbose(2) <<  "Applying no thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying no thermostat..." << endl);
       break;
      case Woodcock:
       if ((configuration.ScaleTempStep > 0) && ((MDSteps-1) % configuration.ScaleTempStep == 0)) {
-        Log() << Verbose(2) <<  "Applying Woodcock thermostat..." << endl;
+        DoLog(2) && (Log() << Verbose(2) <<  "Applying Woodcock thermostat..." << endl);
         ActOnAllAtoms( &atom::Thermostat_Woodcock, sqrt(ScaleTempFactor), MDSteps, &ekin );
       }
       break;
      case Gaussian:
-      Log() << Verbose(2) <<  "Applying Gaussian thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Gaussian thermostat..." << endl);
       ActOnAllAtoms( &atom::Thermostat_Gaussian_init, MDSteps, &G, &E );
 
-      Log() << Verbose(1) << "Gaussian Least Constraint constant is " << G/E << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Gaussian Least Constraint constant is " << G/E << "." << endl);
       ActOnAllAtoms( &atom::Thermostat_Gaussian_least_constraint, MDSteps, G/E, &ekin, &configuration);
 
       break;
      case Langevin:
-      Log() << Verbose(2) <<  "Applying Langevin thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Langevin thermostat..." << endl);
       // init random number generator
       gsl_rng_env_setup();
@@ -677,10 +679,10 @@
 
      case Berendsen:
-      Log() << Verbose(2) <<  "Applying Berendsen-VanGunsteren thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Berendsen-VanGunsteren thermostat..." << endl);
       ActOnAllAtoms( &atom::Thermostat_Berendsen, MDSteps, ScaleTempFactor, &ekin, &configuration );
       break;
 
      case NoseHoover:
-      Log() << Verbose(2) <<  "Applying Nose-Hoover thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Nose-Hoover thermostat..." << endl);
       // dynamically evolve alpha (the additional degree of freedom)
       delta_alpha = 0.;
@@ -688,9 +690,9 @@
       delta_alpha = (delta_alpha - (3.*AtomCount+1.) * configuration.TargetTemp)/(configuration.HooverMass*Units2Electronmass);
       configuration.alpha += delta_alpha*configuration.Deltat;
-      Log() << Verbose(3) << "alpha = " << delta_alpha << " * " << configuration.Deltat << " = " << configuration.alpha << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "alpha = " << delta_alpha << " * " << configuration.Deltat << " = " << configuration.alpha << "." << endl);
       // apply updated alpha as additional force
       ActOnAllAtoms( &atom::Thermostat_NoseHoover_scale, MDSteps, &ekin, &configuration );
       break;
   }
-  Log() << Verbose(1) << "Kinetic energy is " << ekin << "." << endl;
-};
+  DoLog(1) && (Log() << Verbose(1) << "Kinetic energy is " << ekin << "." << endl);
+};
